import cart from "@/api/cart"
// 主题色
export let themeColor={
    "--main-color": "#ffffff",
    "--minor-color": "#ffffff"
}


// 获取link 中页面地址(link兼容 有object或者string)
export function getUrlofLink(data) {
    return data.link
}

// 全局跳转  data:link数据    option:是否为底部栏触发
export function $themeToLink(data, option) {
    let app = getApp();
    let type = data.type;

    // 点击底部栏
    if (option) {
        let parseLink = getUrlofLink(data);
        let isTabbarIndex = checkTabbarPage(parseLink);
        // 替换首页位置
        isTabbarIndex = isTabbarIndex == 0 ? checkTabbarPage('/') : isTabbarIndex
        wx.switchTab({
            url: parseLink == '/' ? '/pages/home/main' : `/pages/tabBar${isTabbarIndex}/main`,
        })
        console.log(option, data)
        return
    }


    // 历史数据
    if (type == undefined || type == 'undefined') {
        if (data.length > 0) {
            toPage(data)
        }
        return
    }

    // 底部导航跳转
    // let parseLink=getUrlofLink(data)
    // let isTabbarIndex =checkTabbarPage(parseLink )
    // if (isTabbarIndex>-1) {
    //     wx.switchTab({
    //         url: parseLink == '/' ? '/pages/home/main' : `/pages/tabBar${isTabbarIndex}/main`,
    //     })
    //     return
    // }


    // -----------------
    if (type == 0) {//无链接
        return
    } else if (type == 1) {//h5页面
        //兼容
        if (data.link.substring(0, 1) == "/") {
            toPage(data.link)
        } else {
            if (data.link.startsWith('http') || data.link.startsWith('https')) {
                wx.navigateTo({ url: '/pages/wxArticle/main?link=' + encodeURIComponent(data.link) });
            }
        }
    } else if (type == 1.1) {//小程序页面  可能增加登录态拦截
        wx.navigateTo({ url: data.link });
    } else if (type == 1.2) { //第三方链接
        if (data.link == 'outerChain:businessCenter') {
            // 进入商家中心外链
            let url = `${config.GUIDE_URL}/login?mixid=${this.$nuxt.$route.query.mixid}&back=${encodeURIComponent(window.location.href)}`;
            wx.navigateTo({ url: '/pages/wxArticle/main?link=' + encodeURIComponent(url) });
            return
        }
        if (data.link.substring(0, 1) == "/") {
            toPage(data.link)
        } else {
            wx.navigateTo({ url: '/pages/wxArticle/main?link=' + encodeURIComponent(data.link) });
        }
    } else if (type == 2) {//功能
        let featureType = data.feature.type;
        if (featureType == 'themeCouponClick' || featureType == 0) {//优惠券
            // this.$themeCouponClick(data.feature.value.couponCode, data.feature.value);
        } else if (featureType == 1) {//分享
            console.log('是分享了。。。。');
            app.shareInit({ itemList: data.feature.value });
        } else if (featureType == "themeMemberCardClick" || featureType == 2) { //会员卡
            // this.$themeMemberCardClick(data.feature.value);
        }
    } else if (type == 3) { //小程序跳转到小程序
        wx.navigateTo({
            url: `/pages/toMini/main?weappPage=${encodeURIComponent(data.link)}&weappAppId=${data.name}`,
        })
    } else {
        //向后兼容
        if (data.length > 0) {
            toPage(data.link);
        }
    }
}
export function $themeAddToCard(item, callback) {
    let app = getApp();
    let errorMsg = "";
    if (item.productNature == 5) {
      errorMsg="电子卡券不可加入购物车";
    }
    if (item.productNature == 3) {
      errorMsg="会员卡不可加入购物车";
    }
    if (item.productNature == 2) {
      errorMsg="虚拟商品不可加入购物车";
    }
    if (errorMsg) {
        wx.showToast({
            title:errorMsg,
            icon: 'none',
        });
    }
    cart
      .addCart([
        { productGoodsId: item.minProductGoodsId, qty: item.saleQty }
      ])
      .then(res => {
        if (res.data.code == 200) {
          wx.showToast({ title: "加入购物车成功", icon: "none" });
        }
        callback();
      });
}

function toPage(backPath, backParams = "") {
    wx.navigateTo({
        url: `../index/main?from=home&backpath=${encodeURIComponent(backPath)}&params=${encodeURIComponent(backParams)}`
    });
}


// check 链接是否为底部导航栏页面 返回索引
export function checkTabbarPage(link) {
    let app = getApp()
    if (!app.globalData.footerVal) return -1
    let footerVal = app.globalData.footerVal.componentData.list;
    let isFooter = footerVal.findIndex(item => {
        return item.link.link == link
    })
    return isFooter
}

// 当前底部栏选中项
export function setTabBarActive(data) {
    console.log(this, 'this', data)
    if (data < 0 || !this.$mp.page) return
    if (typeof this.$mp.page.getTabBar === 'function' &&
        this.$mp.page.getTabBar()) {
        this.$mp.page.getTabBar().setData({
            selected: data
        })
    }
}
